package org.jeecg.modules.projectManagement.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.projectManagement.entity.FdContract;
import org.jeecg.modules.projectManagement.entity.FdContractUpload;
import org.jeecg.modules.projectManagement.service.IFdContractUploadService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;

 /**
 * @Title: Controller
 * @Description: 合同附件表
 * @author： jeecg-boot
 * @date：   2019-11-27
 * @version： V1.0
 */
@RestController
@RequestMapping("/projectManagement/fdContractUpload")
@Slf4j
public class FdContractUploadController {
	@Autowired
	private IFdContractUploadService fdContractUploadService;
	
	/**
	  * 分页列表查询
	 * @param fdContractUpload
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	@GetMapping(value = "/list")
	public Result<IPage<FdContractUpload>> queryPageList(FdContractUpload fdContractUpload,
									  @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
									  @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
									  HttpServletRequest req) {
		Result<IPage<FdContractUpload>> result = new Result<IPage<FdContractUpload>>();
		QueryWrapper<FdContractUpload> queryWrapper = QueryGenerator.initQueryWrapper(fdContractUpload, req.getParameterMap());
		queryWrapper.lambda().eq(FdContractUpload::getDelFlag,"0");
		queryWrapper.lambda().orderByAsc(FdContractUpload::getSort);
		Page<FdContractUpload> page = new Page<FdContractUpload>(pageNo, pageSize);
		IPage<FdContractUpload> pageList = fdContractUploadService.page(page, queryWrapper);
		result.setSuccess(true);
		result.setResult(pageList);
		return result;
	}
	
	/**
	  *   添加
	 * @param fdContractUpload
	 * @return
	 */
	@PostMapping(value = "/add")
	public Result<FdContractUpload> add(@RequestBody FdContractUpload fdContractUpload) {
		Result<FdContractUpload> result = new Result<FdContractUpload>();
		try {
			fdContractUploadService.save(fdContractUpload);
			result.success("添加成功！");
		} catch (Exception e) {
			e.printStackTrace();
			log.info(e.getMessage());
			result.error500("操作失败");
		}
		return result;
	}
	
	/**
	  *  编辑
	 * @param fdContractUpload
	 * @return
	 */
	@PutMapping(value = "/edit")
	public Result<FdContractUpload> edit(@RequestBody FdContractUpload fdContractUpload) {
		Result<FdContractUpload> result = new Result<FdContractUpload>();
		FdContractUpload fdContractUploadEntity = fdContractUploadService.getById(fdContractUpload.getId());
		if(fdContractUploadEntity==null) {
			result.error500("未找到对应实体");
		}else {
			boolean ok = fdContractUploadService.updateById(fdContractUpload);
			//TODO 返回false说明什么？
			if(ok) {
				result.success("修改成功!");
			}
		}
		
		return result;
	}
	
	/**
	  *   通过id删除
	 * @param id
	 * @return
	 */
	@DeleteMapping(value = "/delete")
	public Result<FdContractUpload> delete(@RequestParam(name="id",required=true) String id) {
		Result<FdContractUpload> result = new Result<FdContractUpload>();
		FdContractUpload fdContractUpload = fdContractUploadService.getById(id);
		if(fdContractUpload==null) {
			result.error500("未找到对应实体");
		}else {
			boolean ok = fdContractUploadService.removeById(id);
			if(ok) {
				result.success("删除成功!");
			}
		}
		
		return result;
	}
	
	/**
	  *  批量删除
	 * @param ids
	 * @return
	 */
	@DeleteMapping(value = "/deleteBatch")
	public Result<FdContractUpload> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		Result<FdContractUpload> result = new Result<FdContractUpload>();
		if(ids==null || "".equals(ids.trim())) {
			result.error500("参数不识别！");
		}else {
			this.fdContractUploadService.removeByIds(Arrays.asList(ids.split(",")));
			result.success("删除成功!");
		}
		return result;
	}
	
	/**
	  * 通过id查询
	 * @param id
	 * @return
	 */
	@GetMapping(value = "/queryById")
	public Result<FdContractUpload> queryById(@RequestParam(name="id",required=true) String id) {
		Result<FdContractUpload> result = new Result<FdContractUpload>();
		FdContractUpload fdContractUpload = fdContractUploadService.getById(id);
		if(fdContractUpload==null) {
			result.error500("未找到对应实体");
		}else {
			result.setResult(fdContractUpload);
			result.setSuccess(true);
		}
		return result;
	}

  /**
      * 导出excel
   *
   * @param request
   * @param response
   */
  @RequestMapping(value = "/exportXls")
  public ModelAndView exportXls(HttpServletRequest request, HttpServletResponse response) {
      // Step.1 组装查询条件
      QueryWrapper<FdContractUpload> queryWrapper = null;
      try {
          String paramsStr = request.getParameter("paramsStr");
          if (oConvertUtils.isNotEmpty(paramsStr)) {
              String deString = URLDecoder.decode(paramsStr, "UTF-8");
              FdContractUpload fdContractUpload = JSON.parseObject(deString, FdContractUpload.class);
              queryWrapper = QueryGenerator.initQueryWrapper(fdContractUpload, request.getParameterMap());
          }
      } catch (UnsupportedEncodingException e) {
          e.printStackTrace();
      }

      //Step.2 AutoPoi 导出Excel
      ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
      List<FdContractUpload> pageList = fdContractUploadService.list(queryWrapper);
      //导出文件名称
      mv.addObject(NormalExcelConstants.FILE_NAME, "合同附件表列表");
      mv.addObject(NormalExcelConstants.CLASS, FdContractUpload.class);
      mv.addObject(NormalExcelConstants.PARAMS, new ExportParams("合同附件表列表数据", "导出人:Jeecg", "导出信息"));
      mv.addObject(NormalExcelConstants.DATA_LIST, pageList);
      return mv;
  }

  /**
      * 通过excel导入数据
   *
   * @param request
   * @param response
   * @return
   */
  @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
  public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
      MultipartHttpServletRequest multipartRequest = (MultipartHttpServletRequest) request;
      Map<String, MultipartFile> fileMap = multipartRequest.getFileMap();
      for (Map.Entry<String, MultipartFile> entity : fileMap.entrySet()) {
          MultipartFile file = entity.getValue();// 获取上传文件对象
          ImportParams params = new ImportParams();
          params.setTitleRows(2);
          params.setHeadRows(1);
          params.setNeedSave(true);
          try {
              List<FdContractUpload> listFdContractUploads = ExcelImportUtil.importExcel(file.getInputStream(), FdContractUpload.class, params);
              for (FdContractUpload fdContractUploadExcel : listFdContractUploads) {
                  fdContractUploadService.save(fdContractUploadExcel);
              }
              return Result.ok("文件导入成功！数据行数：" + listFdContractUploads.size());
          } catch (Exception e) {
              log.error(e.getMessage());
              return Result.error("文件导入失败！");
          } finally {
              try {
                  file.getInputStream().close();
              } catch (IOException e) {
                  e.printStackTrace();
              }
          }
      }
      return Result.ok("文件导入失败！");
  }

  /***
   * @Title:批量上传附件以及修改合同附件状态
          * @Description:TODO
          * @param [fdContract]
          * @return org.jeecg.common.api.vo.Result
          * @exception 
          * @author 陈创
          * @date 2019/11/27 16:37
          * @updatehistory:
   *   2019/11/27 16:37 新增
          */
	 @PostMapping(value = "/batchUpload")
	 public Result batchUpload(@RequestBody FdContract fdContract) {
		 Result result = new Result();
		 try {
			 //批量删除
			 LambdaQueryWrapper<FdContractUpload> fdProjectQuotationUploadLambdaQueryWrapper=new LambdaQueryWrapper<>();
			 fdProjectQuotationUploadLambdaQueryWrapper.eq(FdContractUpload::getProjectId,fdContract.getId());
			 fdContractUploadService.remove(fdProjectQuotationUploadLambdaQueryWrapper);

			 //改变报价主表是否上传文件状态
			 fdContractUploadService.contractIsUpload(fdContract);

			 //批量保存
			 fdContractUploadService.saveBatch(fdContract.getFdContractUploadList());
			 result.setSuccess(true);
		 } catch (Exception e) {
			 e.printStackTrace();
			 result.error500("操作失败" + e.getMessage());
		 }
		 return result;
	 }

}
